import{s as Pe,n as Se,o as Ee}from"../chunks/scheduler.69131cc3.js";import{S as ze,i as Oe,g as n,s,r as $,A as Ie,h as l,f as t,c as o,j as m,u as x,x as L,k as c,y as i,a as r,v as y,d as w,t as M,w as N}from"../chunks/index.e1f30d73.js";import{D}from"../chunks/Docstring.ae1a1e2d.js";import{H as Ve}from"../chunks/Heading.0aab6758.js";function ke(xe){let p,J,H,K,C,Q,g,T,ue,k,ye=`Plugin for Megatron-LM to enable tensor, pipeline, sequence and data parallelism. Also to enable selective
activation recomputation and optimized fused kernels.`,W,u,P,de,q,we=`Dummy scheduler presents model parameters or param groups, this is primarily used to follow conventional training
loop when scheduler config is specified in the deepspeed config file.`,X,d,S,_e,A,Me="Dummy dataloader presents model parameters or param groups, this is primarily used to follow conventional training",Y,_,E,ve,B,Ne="Abstract class for batching, forward pass and loss handler.",Z,v,z,fe,G,Le="GPT train step class.",ee,f,O,he,F,De="Bert train step class.",te,h,I,be,U,Ce="T5 train step class.",ae,b,V,$e,j,Te="Average losses across data parallel group.",re,R,ne;return C=new Ve({props:{title:"Utilities for Megatron-LM",local:"accelerate.utils.MegatronLMPlugin",headingTag:"h1"}}),T=new D({props:{name:"class accelerate.utils.MegatronLMPlugin",anchor:"accelerate.utils.MegatronLMPlugin",parameters:[{name:"tp_degree",val:": int = None"},{name:"pp_degree",val:": int = None"},{name:"num_micro_batches",val:": int = None"},{name:"gradient_clipping",val:": float = None"},{name:"sequence_parallelism",val:": bool = None"},{name:"recompute_activations",val:": bool = None"},{name:"use_distributed_optimizer",val:": bool = None"},{name:"pipeline_model_parallel_split_rank",val:": int = None"},{name:"num_layers_per_virtual_pipeline_stage",val:": int = None"},{name:"is_train_batch_min",val:": str = True"},{name:"train_iters",val:": int = None"},{name:"train_samples",val:": int = None"},{name:"weight_decay_incr_style",val:": str = 'constant'"},{name:"start_weight_decay",val:": float = None"},{name:"end_weight_decay",val:": float = None"},{name:"lr_decay_style",val:": str = 'linear'"},{name:"lr_decay_iters",val:": int = None"},{name:"lr_decay_samples",val:": int = None"},{name:"lr_warmup_iters",val:": int = None"},{name:"lr_warmup_samples",val:": int = None"},{name:"lr_warmup_fraction",val:": float = None"},{name:"min_lr",val:": float = 0"},{name:"consumed_samples",val:": List = None"},{name:"no_wd_decay_cond",val:": Optional = None"},{name:"scale_lr_cond",val:": Optional = None"},{name:"lr_mult",val:": float = 1.0"},{name:"megatron_dataset_flag",val:": bool = False"},{name:"seq_length",val:": int = None"},{name:"encoder_seq_length",val:": int = None"},{name:"decoder_seq_length",val:": int = None"},{name:"tensorboard_dir",val:": str = None"},{name:"set_all_logging_options",val:": bool = False"},{name:"eval_iters",val:": int = 100"},{name:"eval_interval",val:": int = 1000"},{name:"return_logits",val:": bool = False"},{name:"custom_train_step_class",val:": Optional = None"},{name:"custom_train_step_kwargs",val:": Optional = None"},{name:"custom_model_provider_function",val:": Optional = None"},{name:"custom_prepare_model_function",val:": Optional = None"},{name:"other_megatron_args",val:": Optional = None"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/utils/dataclasses.py#L1173"}}),P=new D({props:{name:"class accelerate.utils.MegatronLMDummyScheduler",anchor:"accelerate.utils.MegatronLMDummyScheduler",parameters:[{name:"optimizer",val:""},{name:"total_num_steps",val:" = None"},{name:"warmup_num_steps",val:" = 0"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"accelerate.utils.MegatronLMDummyScheduler.optimizer",description:`<strong>optimizer</strong> (<code>torch.optim.optimizer.Optimizer</code>) &#x2014;
The optimizer to wrap.`,name:"optimizer"},{anchor:"accelerate.utils.MegatronLMDummyScheduler.total_num_steps",description:`<strong>total_num_steps</strong> (int) &#x2014;
Total number of steps.`,name:"total_num_steps"},{anchor:"accelerate.utils.MegatronLMDummyScheduler.warmup_num_steps",description:`<strong>warmup_num_steps</strong> (int) &#x2014;
Number of steps for warmup.
**kwargs &#x2014;
Other arguments.`,name:"warmup_num_steps"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/utils/megatron_lm.py#L413"}}),S=new D({props:{name:"class accelerate.utils.MegatronLMDummyDataLoader",anchor:"accelerate.utils.MegatronLMDummyDataLoader",parameters:[{name:"**dataset_kwargs",val:""}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/utils/megatron_lm.py#L144"}}),E=new D({props:{name:"class accelerate.utils.AbstractTrainStep",anchor:"accelerate.utils.AbstractTrainStep",parameters:[{name:"name",val:""}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/utils/megatron_lm.py#L450"}}),z=new D({props:{name:"class accelerate.utils.GPTTrainStep",anchor:"accelerate.utils.GPTTrainStep",parameters:[{name:"args",val:""}],parametersDescription:[{anchor:"accelerate.utils.GPTTrainStep.args",description:"<strong>args</strong> (<code>argparse.Namespace</code>) &#x2014; Megatron-LM arguments.",name:"args"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/utils/megatron_lm.py#L596"}}),O=new D({props:{name:"class accelerate.utils.BertTrainStep",anchor:"accelerate.utils.BertTrainStep",parameters:[{name:"args",val:""}],parametersDescription:[{anchor:"accelerate.utils.BertTrainStep.args",description:"<strong>args</strong> (<code>argparse.Namespace</code>) &#x2014; Megatron-LM arguments.",name:"args"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/utils/megatron_lm.py#L467"}}),I=new D({props:{name:"class accelerate.utils.T5TrainStep",anchor:"accelerate.utils.T5TrainStep",parameters:[{name:"args",val:""}],parametersDescription:[{anchor:"accelerate.utils.T5TrainStep.args",description:"<strong>args</strong> (<code>argparse.Namespace</code>) &#x2014; Megatron-LM arguments.",name:"args"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/utils/megatron_lm.py#L702"}}),V=new D({props:{name:"accelerate.utils.avg_losses_across_data_parallel_group",anchor:"accelerate.utils.avg_losses_across_data_parallel_group",parameters:[{name:"losses",val:""}],parametersDescription:[{anchor:"accelerate.utils.avg_losses_across_data_parallel_group.losses",description:"<strong>losses</strong> (List[Tensor]) &#x2014; List of losses to average across data parallel group.",name:"losses"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/utils/megatron_lm.py#L1404"}}),{c(){p=n("meta"),J=s(),H=n("p"),K=s(),$(C.$$.fragment),Q=s(),g=n("div"),$(T.$$.fragment),ue=s(),k=n("p"),k.textContent=ye,W=s(),u=n("div"),$(P.$$.fragment),de=s(),q=n("p"),q.textContent=we,X=s(),d=n("div"),$(S.$$.fragment),_e=s(),A=n("p"),A.textContent=Me,Y=s(),_=n("div"),$(E.$$.fragment),ve=s(),B=n("p"),B.textContent=Ne,Z=s(),v=n("div"),$(z.$$.fragment),fe=s(),G=n("p"),G.textContent=Le,ee=s(),f=n("div"),$(O.$$.fragment),he=s(),F=n("p"),F.textContent=De,te=s(),h=n("div"),$(I.$$.fragment),be=s(),U=n("p"),U.textContent=Ce,ae=s(),b=n("div"),$(V.$$.fragment),$e=s(),j=n("p"),j.textContent=Te,re=s(),R=n("p"),this.h()},l(e){const a=Ie("svelte-u9bgzb",document.head);p=l(a,"META",{name:!0,content:!0}),a.forEach(t),J=o(e),H=l(e,"P",{}),m(H).forEach(t),K=o(e),x(C.$$.fragment,e),Q=o(e),g=l(e,"DIV",{class:!0});var se=m(g);x(T.$$.fragment,se),ue=o(se),k=l(se,"P",{"data-svelte-h":!0}),L(k)!=="svelte-51ubws"&&(k.textContent=ye),se.forEach(t),W=o(e),u=l(e,"DIV",{class:!0});var le=m(u);x(P.$$.fragment,le),de=o(le),q=l(le,"P",{"data-svelte-h":!0}),L(q)!=="svelte-mxz6g6"&&(q.textContent=we),le.forEach(t),X=o(e),d=l(e,"DIV",{class:!0});var oe=m(d);x(S.$$.fragment,oe),_e=o(oe),A=l(oe,"P",{"data-svelte-h":!0}),L(A)!=="svelte-1r57fhg"&&(A.textContent=Me),oe.forEach(t),Y=o(e),_=l(e,"DIV",{class:!0});var ie=m(_);x(E.$$.fragment,ie),ve=o(ie),B=l(ie,"P",{"data-svelte-h":!0}),L(B)!=="svelte-7ith7r"&&(B.textContent=Ne),ie.forEach(t),Z=o(e),v=l(e,"DIV",{class:!0});var me=m(v);x(z.$$.fragment,me),fe=o(me),G=l(me,"P",{"data-svelte-h":!0}),L(G)!=="svelte-8o1bfn"&&(G.textContent=Le),me.forEach(t),ee=o(e),f=l(e,"DIV",{class:!0});var ce=m(f);x(O.$$.fragment,ce),he=o(ce),F=l(ce,"P",{"data-svelte-h":!0}),L(F)!=="svelte-1af56j7"&&(F.textContent=De),ce.forEach(t),te=o(e),h=l(e,"DIV",{class:!0});var pe=m(h);x(I.$$.fragment,pe),be=o(pe),U=l(pe,"P",{"data-svelte-h":!0}),L(U)!=="svelte-1w9r8gv"&&(U.textContent=Ce),pe.forEach(t),ae=o(e),b=l(e,"DIV",{class:!0});var ge=m(b);x(V.$$.fragment,ge),$e=o(ge),j=l(ge,"P",{"data-svelte-h":!0}),L(j)!=="svelte-39hqbl"&&(j.textContent=Te),ge.forEach(t),re=o(e),R=l(e,"P",{}),m(R).forEach(t),this.h()},h(){c(p,"name","hf:doc:metadata"),c(p,"content",qe),c(g,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(u,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(d,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(_,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(v,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(f,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(h,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(b,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(e,a){i(document.head,p),r(e,J,a),r(e,H,a),r(e,K,a),y(C,e,a),r(e,Q,a),r(e,g,a),y(T,g,null),i(g,ue),i(g,k),r(e,W,a),r(e,u,a),y(P,u,null),i(u,de),i(u,q),r(e,X,a),r(e,d,a),y(S,d,null),i(d,_e),i(d,A),r(e,Y,a),r(e,_,a),y(E,_,null),i(_,ve),i(_,B),r(e,Z,a),r(e,v,a),y(z,v,null),i(v,fe),i(v,G),r(e,ee,a),r(e,f,a),y(O,f,null),i(f,he),i(f,F),r(e,te,a),r(e,h,a),y(I,h,null),i(h,be),i(h,U),r(e,ae,a),r(e,b,a),y(V,b,null),i(b,$e),i(b,j),r(e,re,a),r(e,R,a),ne=!0},p:Se,i(e){ne||(w(C.$$.fragment,e),w(T.$$.fragment,e),w(P.$$.fragment,e),w(S.$$.fragment,e),w(E.$$.fragment,e),w(z.$$.fragment,e),w(O.$$.fragment,e),w(I.$$.fragment,e),w(V.$$.fragment,e),ne=!0)},o(e){M(C.$$.fragment,e),M(T.$$.fragment,e),M(P.$$.fragment,e),M(S.$$.fragment,e),M(E.$$.fragment,e),M(z.$$.fragment,e),M(O.$$.fragment,e),M(I.$$.fragment,e),M(V.$$.fragment,e),ne=!1},d(e){e&&(t(J),t(H),t(K),t(Q),t(g),t(W),t(u),t(X),t(d),t(Y),t(_),t(Z),t(v),t(ee),t(f),t(te),t(h),t(ae),t(b),t(re),t(R)),t(p),N(C,e),N(T),N(P),N(S),N(E),N(z),N(O),N(I),N(V)}}}const qe='{"title":"Utilities for Megatron-LM","local":"accelerate.utils.MegatronLMPlugin","sections":[],"depth":1}';function Ae(xe){return Ee(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class je extends ze{constructor(p){super(),Oe(this,p,Ae,ke,Pe,{})}}export{je as component};
